#ifndef __GLOBAL_SINGLETON_H
#define __GLOBAL_SINGLETON_H
#include <assert.h>

template <class T>
class Global_Singleton
{
public:
	Global_Singleton()
	{
		assert(g_ptr == 0);
		g_ptr = (T *)this;
	}
	~Global_Singleton()
	{
		assert(g_ptr == this);
		g_ptr = 0;
	}

	static T *Get() { assert(g_ptr != 0); return g_ptr; }
	static T *Try_Get() { return g_ptr; }

private:
	static T *g_ptr;
};

template <class T> T *Global_Singleton<T>::g_ptr = 0;

#endif
