#ifndef __INPUT_H
#define __INPUT_H
#define WIN32_MEAN_AND_LEAN
#include <windows.h>
#define DIRECTINPUT_VERSION 0x0800
#include <dinput.h>
#include <d3dx9.h>
#include "Global_Singleton.h"

class Input
	: public Global_Singleton<Input>
{
public:
	Input(HINSTANCE inst, HWND wnd);
	~Input();

	void Acquire();
	void Poll();

	D3DXVECTOR2 Get_Mouse_Delta() const;
	bool Left_Mouse_Pressed() const;
	bool Right_Mouse_Pressed() const;

private:
	LPDIRECTINPUT8 m_di;
	LPDIRECTINPUTDEVICE8 m_mouse;

	D3DXVECTOR2 m_mouse_delta;
	bool m_lmb_pressed;
	bool m_rmb_pressed;
};

#endif
